--------------------------------------------------------------------------------
-- House of Winters - URL encoding/decoding.
--------------------------------------------------------------------------------
-- http://lua-users.org/wiki/StringRecipes
--------------------------------------------------------------------------------
-- Usage:
-- local url = LibStub:GetLibrary("LibURLEncode-1.0")
-- local encoded = url:encode(string)
-- local decoded = url:decode(string)
--------------------------------------------------------------------------------

local MAJOR, MINOR = "LibURLEncode-1.0", 0
local url, oldminor = LibStub:NewLibrary(MAJOR, MINOR)
if not url then return end	--the same or newer version of this lib is already loaded into memory

--- URL encode a string.
-- @param str string the string to encode.
-- @return the encoded link
function url:encode(str)
  if (str) then
    str = string.gsub (str, "\n", "\r\n")
    str = string.gsub (str, "([^%w %-%_%.%~])",
        function (c) return string.format ("%%%02X", string.byte(c)) end)
    str = string.gsub (str, " ", "+")
  end
  return str
end


--- URL decode a string.
-- @param str string the string to encode.
-- @return the encoded string
function url:decode(str)
  str = string.gsub (str, "+", " ")
  str = string.gsub (str, "%%(%x%x)",
      function(h) return string.char(tonumber(h,16)) end)
  str = string.gsub (str, "\r\n", "\n")
  return str
end
